# Functions for autocutter.sh


function cut_with_vdrcutter2() {

  # Are Recordings Stored on more than one Filesystem ?
  NameLen=$(echo $VDRROOT | wc -c)
  let NameLen=NameLen-1
  LastChar=$(echo $VDRROOT | cut -c $NameLen)
  StartCount=99
  if [ "$LastChar" = "0" ]; then
    StartCount=0
  else
    let TestChar=LastChar
    [ $TestChar -gt 0 ] && StartCount=$TestChar
  fi

  # If Recordings are Stored on more than one Filesystem ...
  # then find the one with most space Free
  if [ $StartCount -ne 99 ]; then
    let NameLen=NameLen-1
    LargestDir=
    LargestSize=0
    DirCount=$StartCount
    while [ $DirCount -le 9 ]; do
      VideoDir=$(echo $VDRROOT | cut -c 1-$NameLen)$DirCount
      if [ -e $VideoDir ]; then
	DiskFree=$(df -k $VideoDir |tail -1|awk '{print $4}')
	[ $DiskFree -ge $LargestSize ] && LargestSize=$DiskFree && LargestDir=$VideoDir
      fi
      let DirCount=DirCount+1
    done
  fi


  # Create new Directory for Cut Recording
  mkdir -p $CutDir

  # Reset Status
  STATUS=0

  # If not several /video dirs
  if [ "$LargestDir" = "$VDRROOT" ]; then
    CutDirLarge="$CutDir"
  else
    # We have Several Video Partitions

    # Directory where ???.vdr Files are saved 
    CutDirLarge=$(echo $CutDir | sed -e "s/`basename $VDRROOT`/`basename $LargestDir`/g")

    if [ ! -d $CutDirLarge ]; then
      mkdir -p $CutDirLarge
    else
      [ ! "$RECALREADYCUT_MSG" = "NO" ] && printf "$RECALREADYCUT_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG

      # Remove empty Directories
      rmdir $CutDir >>$LOGFILE 2>&1
      rmdir $CutDirLarge >>$LOGFILE 2>&1

      printf "\nRecording $RecName was already Cut or an error has occurred!\n" >>$LOGFILE
      printf "\n\nATTENSION !!!! This means that there is an bug in this Script or that there are unused Files on the $LargestDir Partition \n\n" >>$LOGFILE
      printf "Directory %s DID NOT exist when we started ...\n" "$CutDir" >>$LOGFILE
      [ -d $CutDir ] && printf "\nBut now it DOES exist !!! - did you start cutting Manually ?\n" >>$LOGFILE
      printf "Directory %s exist ...\n\n\n" "$CutDirLarge" >>$LOGFILE

      return 1
    fi
  fi

  
  [ ! "$ACSTART_MSG" = "NO" ] && printf "$ACSTART_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG

  # Is enough Space there ? $CUTFREESPACEPCT % is needed !
  RecUsedSpace=$(du -kL $CurJob|tail -1|awk '{ print $1 }')
  DiskFree=$(df -k $LargestDir |tail -1|awk '{print $4}')
  let TestSpace=RecUsedSpace/100*$CUTFREESPACEPCT
  printf "\nRecUsedSpace=$RecUsedSpace, TestSpace=$TestSpace\n" >>$LOGFILE

  if [ $DiskFree -ge $TestSpace ]; then

    # Start Cutting
    $VDRCUTTER2 2>&1|grep "1.2.5.2" >/dev/null 2>&1
    if [ $? -eq 0 ]; then
      $VDRCUTTER2 -d "$CutDirLarge" -s "$CurJob" >>$LOGFILE 2>&1
      STATUS=$?
    else
      printf "\n\nATTENSION !!! you have to UPDATE your vdrcutter2 Version - read README !!!\n\n" >>$LOGFILE
      $SVDRPSEND MESG "vdrcutter2 is to old - see README !"

      # Add to Queue again
      printf "%s " "$CurJob" >>$AUTOCUTQUEUE

      return 1
    fi

  else
    [ ! "$ACNOTENOUGHSPACE" = "NO" ] && printf "$ACNOTENOUGHSPACE" "$RecNameMSG" |xargs $SVDRPSEND MESG
    printf "\n\nThere is not enough Free Space on the Disk for %s\n\n" $CurJob >>$LOGFILE 

    # Add to Queue again
    printf "%s " "$CurJob" >>$AUTOCUTQUEUE

    return 1
  fi


  if [ $STATUS -ne 0 ]; then
    printf "\nAutoCutter FAILED for $RecName !!\n" >>$LOGFILE
    printf "$VDRCUTTER2 stopped with Exit Status $STATUS !?\n" >>$LOGFILE
    [ ! "$ACFAILED_MSG" = "NO" ] && printf "$ACFAILED_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG 

    # Remove Created Directories
    [ -d $CutDir ] && rm -rf $CutDir >>$LOGFILE 2>&1
    [ -d $CutDirLarge ] && rm -rf $CutDirLarge >>$LOGFILE 2>&1

    # Add to Queue again
    printf "%s " "$CurJob" >>$AUTOCUTQUEUE

  else
    # If Recording was Stored on Several Partitions then we have something to do
    if [ ! "$LargestDir" = "$VDRROOT" ]; then
      printf "\nMove index.vdr and marks.vdr to Primary Video Partition ...\n" >>$LOGFILE

      # Create Links on Primary Video Partition to recording
      ln -s $CutDirLarge/[0-9][0-9][0-9].vdr $CutDir/

      # Move index and marks to Primary partition
      mv -vf $CutDirLarge/index.vdr $CutDir/ >>$LOGFILE
      mv -vf $CutDirLarge/marks.vdr $CutDir/ >>$LOGFILE
    fi

    # Copy Summary Infos
    if [ -f $CurJob/summary.vdr ]; then
      printf "\nCopy summary.vdr to Primary Video Partition ...\n" >>$LOGFILE
      cp -vf $CurJob/summary.vdr $CutDir/ >>$LOGFILE
    fi

    # List Files/links ind the Video Directories
    printf "\nWhat is in the Destination Directory after Cutting\n" >>$LOGFILE
    if [ ! "$LargestDir" = "$VDRROOT" ]; then
      printf "%s :\n" "$CutDir" >>$LOGFILE
      ls -l $CutDir >>$LOGFILE
    fi
    printf "%s :\n" "$CutDirLarge" >>$LOGFILE
    ls -l $CutDirLarge >>$LOGFILE

    # For Postaction
    NewRecName=$CutDir

    # Delete OLD recording if Cut was OK
    delete_cutted_recording

    printf "\n`date` : AutoCutter Finished for $RecName\n\n" >>$LOGFILE
    [ ! "$ACFINISHED_MSG" = "NO" ] && printf "$ACFINISHED_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG 

  fi

}


function cut_with_vdr() {

  # Start cutting
  DateSearch="`basename $CurJob | cut -b 9-10`.`basename $CurJob | cut -b 6-7` `basename $CurJob | cut -b 12-13`:`basename $CurJob | cut -b 15-16`"
  RECNUM=`$SVDRPSEND LSTR | grep "$(echo $RecName|sed -e 's/_/ /g')" | grep "$DateSearch" | cut -b 5-20 | cut -f 1 -d ' '`

  # if any user is using the menus set it back to normal ;)
  $SVDRPSEND HITK Menu
  $SVDRPSEND HITK Back

  [ ! "$ACSTART_MSG" = "NO" ] && printf "$ACSTART_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG && sleep 3 && $SVDRPSEND HITK Back

  $SVDRPSEND LOAD $RECNUM
  sleep 1

  # Was it the right recording that we loaded ?
  tail -5 $LOGFILE| grep "`echo $RecName|sed -e 's/_/ /g'`"
  if [ $? -eq 0 ]; then
    sleep 3
    $SVDRPSEND HITK 2
    sleep 2
    $SVDRPSEND HITK Ok
    $SVDRPSEND HITK Blue

    sleep 5
    tail -10 /var/log/messages | grep "video cutting thread started" 
    if [ $? -eq 0 ]; then
      [ ! "$ACOKSTART_MSG" = "NO" ] && printf "$ACOKSTART_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG 
      printf "\nCutting has started.\n" >>$LOGFILE
    fi
    sleep 5

    #  If Cutted Recording not there then wait some time
    [ ! -d $CutDir ] && sleep 10

    # Is the Cutted Recording now there ?
    if [ -d $CutDir ]; then
      # For Postaction
      NewRecName=$CutDir

      # Wait until Cutting is Finished
      UsedSpace=0
      NewUsedSpace=`du -L --total $CutDir |tail -1|awk '{ print $1 }'`
      while [ $UsedSpace -ne $NewUsedSpace ]; do
        sleep 10
        UsedSpace=$NewUsedSpace
        NewUsedSpace=`du -L --total $CutDir |tail -1|awk '{ print $1 }'`
        [ $UsedSpace -ne $NewUsedSpace ] && printf "\nCut Process still working ..." >>$LOGFILE
      done

      # Delete OLD recording if Cut was OK
      delete_cutted_recording

      printf "\n`date` : AutoCutter Finished for $RecName\n\n" >>$LOGFILE
      [ ! "$ACFINISHED_MSG" = "NO" ] && printf "$ACFINISHED_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG 
    else
      printf "\nAutoCutter FAILED for $RecName !!\n" >>$LOGFILE
      printf "The new Directory for the cutted Recording was not Created :\n%s\n" $CutDir >>$LOGFILE
      printf "Maybe cutting did not start !?\n" >>$LOGFILE
      [ ! "$ACFAILED_MSG" = "NO" ] && printf "$ACFAILED_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG 
    fi

  else
    printf "\n\nWrong Recording was Loaded - cancel Cutting !!!\n\n"
    sleep 2
    $SVDRPSEND HITK Ok
    $SVDRPSEND HITK Blue
    [ ! "$ACWRONGREC_MSG" = "NO" ] && printf "$ACWRONGREC_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG 
  fi
}


delete_cutted_recording() {

  # How Big is the New Recording ?
  NewUsedSpace=`du -L --total $CutDir |tail -1|awk '{ print $1 }'`

  # How big was the original recording
  RecUsedSpace=`du -L --total $CurJob |tail -1|awk '{ print $1 }'`

  # If Cutted recording is $CUTRECPRCT % of the original then OK to Delete
  let TestSpace=RecUsedSpace/100*$CUTRECPRCT
  if [ $NewUsedSpace -ge $TestSpace -a $NewUsedSpace -gt 0 ]; then
    printf "\nCutted Recording is more than $CUTRECPRCT Percent of Original Recording.\n" >>$LOGFILE
    printf "Original Recording : $RecUsedSpace\nCutted Recording : $NewUsedSpace\n" >>$LOGFILE
    # Move recording to *.del so that it is deleted by VDR.
    if [ "$DELCUTREC" = "yes" ]; then
      DelRecName=`echo $CurJob|sed -e 's/\.rec$/\.del/g'`
      mv $CurJob $DelRecName
      printf "\nRecording $RecName is now DELETED - new name :\n$DelRecName\n" >>$LOGFILE
      # Add Deleted Recoding to Delete Queue !
      # printf "%s " "$DelRecName" >>/etc/vdr/vdrconvert/autocutter_delete
    fi
  else
    printf "\nCutted Recording was LESS than $CUTRECPRCT Percent of Original Recording\n" >>$LOGFILE
    printf "Original Recording : $RecUsedSpace\nCutted Recording : $NewUsedSpace\n" >>$LOGFILE
    [ "$DELCUTREC" = "yes" ] && printf "\nTherfore Recording $RecName is NOT Deleted.\n" >>$LOGFILE
  fi
	      
}

function main_program() {

  # Find name for Recording after Cutting (with % in front)
  CutDir=""
  Count=1
  for x in $(echo $CurJob|sed 's/\// /g'); do
    let Count=Count+1
    [ $Count -ne $DirNum ] && CutDir=$CutDir/$x || CutDir=$CutDir/%$RecName
  done

  # Is Recording already Cut ?
  if [ -d $CutDir ]; then
    [ ! "$RECALREADYCUT_MSG" = "NO" ] && printf "$RECALREADYCUT_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG
    printf "\nRecording $RecName was already Cut !\n" >>$LOGFILE

    return 1
  fi

  # Are the Cut Marks there
  if [ -s "$CurJob/marks.vdr" ]; then

    # For Postaction
    NewRecName=""

    printf "\nNow Cutting $RecName ...\n" >>$LOGFILE

    if [ $USEVDRCUTTER2 = "no" ]; then
      # Start Cutting with VDR
      cut_with_vdr
    else
      # Start Cutting with vdrcutter2
      cut_with_vdrcutter2
    fi

    # Postaction - what should be done after Cutting !
    [ ! -z $AC_POSTACTION ] && [ ! "$NewRecName" = "" ] && $AC_POSTACTION autocutter $NewRecName


  else
    [ ! "$ACNOMARKS_MSG" = "NO" ] && printf "$ACNOMARKS_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG 
    printf "\nError no marks.vdr found for $RecName\n" >>$LOGFILE
  fi

}
