#!/bin/sh

# Parameter 1 is either noad or autocutter
# Parameter 2 is the Recording that was Scanned or the new cutted Recording

###########################################################################
#
# This is the more advanced version of the Script ;)
#
###########################################################################

# This is only a couple of Examples of the Possibilities.


# We will work with different Queues for Different Series here - the Idea is to
# Burn only Recordings of the same Series on one DVD :)
#
# And when enough recordings are in a Queue we automatically start the 
# Conversion.
#
# At what time you burn the Images is your decision - take a look at the 
# vdrconvert README for more.

# INSTALLATION 
#
# A couple of changes are needed in vdrconvert.
#
# first you need to install vdrconvert and get vdr2dvd running.
#
# Then you add different Queues to vdrconvert for the different Series
# It is very easy - here is an example for Deep Space 9 :
#
# cd /etc/vdr/vdrconvert
# ln -s vdr2dvd.sh vdr2dvd-ds9.sh
#
# Now edit vdrconvert.env and add vdr2dvd-ds9 to the CONVERT_JOBS line like this
#
# CONVERT_JOBS="noad autocutter vdr2dvd vdr2dvd-ds9"
#
# now Restart vdrconvert.sh (Queue handler) with the Initscrupt :
# /etc/init.d/vdrconvert stop; /etc/init.d/vdrconvert start
#
# That's all 
#
# This you can do for all the other Series you want on seperate DVD's
#
# Now you need to take a look at this script.

case "$1" in
  noad)
	# Another Example - does not work with the above -DS9 Queue !!!
	#
	# Add to repack2mpeg queue (no idea if this works - just an example
	# repack2mpeg2 don't need cutted recordings to work - see ML for more)

	# printf "cat true 1 %s\n" $2 >> /video/repackmpeg2/xform.lst
    ;;
  autocutter)
	Queued=no

	# add "The Simpsons" to vdr2divx Queue and Convert as soon as possible
        [ $(echo $2|grep -i "the simpsons") ] && Queued=yes && printf "%s\n" $2 >>/etc/vdr/vdrconvert/vdr2divx

	# Add Deep Space Nine to vdr2dvd-ds9 Queue - you might have to define 
	# that "grep" selection a bit more precise
	[ $Queued = no ] && if [ $(echo $2|grep -i "deep space nine") ]; then
	  Queued=yes
	  printf "%s " $2 >>/etc/vdr/vdrconvert/vdr2dvd-ds9

	  # For every 4th Recording Create a new DVD :) - could be a bit 
	  # dangerous - if you add files yourself while this script runs ;)
	  # After inserting NewLine the converting is started !!
	  [ $(cat /etc/vdr/vdrconvert/vdr2dvd-ds9|wc -w) -ge 4 ] && printf "\n" >>/etc/vdr/vdrconvert/vdr2dvd-ds9
	fi

	# .... and so on ....
    ;;
  *)
    logger "$(basename $0) : ERROR - unknown state: $1"
    ;;
esac
