# Queue functions for vdrconvert
#
# Extracted from vdr2dvd.sh - part of vdrconvert - thanks to Dimitri / vdrportal

function queue_management() {

[ -z "$RECNOTFOUND_MSG" ] && RECNOTFOUND_MSG="Recording %s not found"
[ -z "$RECALREADYCUT_MSG" ] && RECALREADYCUT_MSG="Recording %s was already Cut !"
[ -z "$AC_JOBSDONE_MSG" ] && AC_JOBSDONE_MSG="%s : %s Jobs Done"
[ -z "$NOAD_JOBSDONE_MSG" ] && NOAD_JOBSDONE_MSG="%s : %s Jobs Done"

NewJobs=$1
JOBFIL=$2
LOGFILE=$3

let LINES=0
LINES=`cat ${JOBFIL}|wc -l`
if [ $LINES -gt 0 ]
then
    cat ${JOBFIL}|head -n $LINES ${JOBFIL} | grep '^/' > ${NewJobs}
fi
[ `nl $JOBFIL |tail -1|awk '{ print $1 }'` -ne `wc -l $JOBFIL|awk '{ print $1 }'` ] && printf "%s " `tail -1 $JOBFIL` > $JOBFIL || < /dev/null > $JOBFIL

# Count how many Jobs was done
CountJobs=0

while [ `cat $NewJobs|wc -l` -gt 0 ]
do

  CMDLIN=`head -n1 $NewJobs`   # Job auslesen

  printf "\n---------------------------------------------------------------\n\n" >>$LOGFILE
  echo "`date` : Start $(basename $0) for Parts $CMDLIN" | tee -a ${JOBFIL}.done >>$LOGFILE

  for CurJob in $CMDLIN; do

    # Count how many Jobs was done
    let CountJobs=CountJobs+1

    # Find Recording name
    DirNum=$(echo $CurJob|sed 's/\// /g'|wc -w)
    RecName=$(echo $CurJob|sed 's/\// /g'|cut -f$DirNum -d ' ')

    # In VDR Messages we don't want any "_"
    RecNameMSG=$(echo $RecName|sed -e 's/_/ /g')

    printf "\n`date` : Start of $(basename $0) for $RecName\n" >>$LOGFILE

    # Is recording there (maybe deleted or renamed) ?
    if [ -d $CurJob ]; then

	# Start Main Program that does the real work :)
	main_program

    else
      [ ! "$RECNOTFOUND_MSG" = "NO" ] && printf "$RECNOTFOUND_MSG" "$RecNameMSG" |xargs $SVDRPSEND MESG

      printf "\nRecording $RecName was not found (Deleted/Renamed ?)\n" >>$LOGFILE
    fi

  done

  printf "\n`date` : Parts from $CMDLIN completed\n" | tee -a ${JOBFIL}.done >>$LOGFILE

  # Next Job
  cp $NewJobs $NewJobs.$$
  grep -x -v "$CMDLIN" $NewJobs.$$ > $NewJobs
  rm -f $NewJobs.$$

done

# Cleanup tempfile
rm -f $NewJobs

[ "$(basename $0)" = "autocutter.sh" ] && [ ! "$AC_JOBSDONE_MSG" = "NO" ] && printf "$AC_JOBSDONE_MSG" "AutoCutter" "$CountJobs" |xargs $SVDRPSEND MESG
[ "$(basename $0)" = "noad.sh" ] && [ ! "$NOAD_JOBSDONE_MSG" = "NO" ] && printf "$NOAD_JOBSDONE_MSG" "NoAD" "$CountJobs" |xargs $SVDRPSEND MESG

}

